﻿B4J=true
Group=Models
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private mDB As SQL
End Sub


Public Sub GetConnection As SQL
	Return mDB
End Sub

Public Sub CreateConnection
	If mDB.IsInitialized Then Return
	
	Dim FileName As String = "KeeperBase.db"
	Dim xui As XUI
	
	mDB.Initialize(xui.DefaultFolder, FileName, True)
	
	CreateTables
End Sub

Private Sub CreateTables
	mDB.AddNonQueryToBatch("CREATE TABLE IF NOT EXISTS Games (GameID INTEGER PRIMARY KEY, DisplayName TEXT, GameType INTEGER NOT NULL, CreatedOn INTEGER, FinishedOn INTEGER, WinnerName TEXT)", Null)
	mDB.AddNonQueryToBatch("CREATE TABLE IF NOT EXISTS Players (PlayerID INTEGER PRIMARY KEY, PlayerName TEXT, GamesWon INTEGER DEFAULT 0, LastWon INTEGER DEFAULT 0, TotalScore INTEGER DEFAULT 0, TotalBalances TEXT)", Null)
	mDB.AddNonQueryToBatch("CREATE TABLE IF NOT EXISTS Scores (ScoreID INTEGER PRIMARY KEY, GameID INTEGER, PlayerID INTEGER, RoundID INTEGER, ScoreChange INTEGER)", Null)
	mDB.AddNonQueryToBatch("CREATE TABLE IF NOT EXISTS ScoreMeta (GameID INTEGER PRIMARY KEY, MaxScore INTEGER, ReverseScoring INTEGER)", Null)
	mDB.ExecNonQueryBatch("CT")
End Sub

Private Sub CT_NonQueryComplete (Success As Boolean)
	Log ($"Database Connection Success: ${Success.As(String).ToUpperCase}"$)
End Sub

Public Sub CreateLogMessage (Module As String, SubName As String, Succcess As Boolean, OptionalMsg As String)
	Log ($"Module: ${Module} | Sub: ${SubName} | Success: ${Succcess.As(String).ToUpperCase} ${IIf(OptionalMsg <> "", OptionalMsg, "")}"$)
End Sub

'Sub To convert a Integer to a Bool for SQL.
Public Sub IntToBool (Num As Int) As Boolean
	Dim DM As Map = CreateMap(0:False, 1:True)
	Return DM.Get(Num)
End Sub

'Sub to convert a Boolean to an Integer for SQL.
Public Sub BoolToInt (Bool As Boolean) As Int
	Dim DM As Map = CreateMap(False:0, True:1)
	Return DM.Get(Bool)
End Sub

Public Sub GetLastInsertedGameID As Int
	Return mDB.ExecQuerySingleResult("SELECT GameID FROM Games ORDER BY GameID DESC LIMIT 1")
End Sub

Public Sub GetLastInsertRowID As Int
	Return mDB.ExecQuerySingleResult("SELECT last_insert_rowid()")
End Sub

Public Sub GetTotalChanges As Int
	Return mDB.ExecQuerySingleResult("SELECT total_changes()")
End Sub