﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.8
@EndOfDesignText@
Sub Class_Globals
	Public BackgroundColor As Int
	Public ItemBackground As Int
	Public ItemTextColor As Int
	Public PressedColor As Int
	#If B4A
	Private stub As B4XView 'ignore
	#End If
	Private xui As XUI
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
'	BackgroundColor = xui.Color_Transparent
'	ItemBackground = xui.Color_White
'	ItemTextColor = xui.Color_Black
	PressedColor = xui.Color_RGB(120,255,0)
End Sub

'The panel should include a single label. The label text properties will be used and the label will be removed.
'Parameters: Panel, EventName, [label, tag]+
Private Sub CreateToolbar (DesignerArgs As DesignerArgs)
	Dim pnl As B4XView = DesignerArgs.GetViewFromArgs(0)
	pnl.Color = B4XPages.MainPage.Theme.GetColor("Main")
	If DesignerArgs.FirstRun Then
		Dim StubLabel As B4XView = pnl.GetView(0)
		StubLabel.RemoveViewFromParent
		Dim EventName As String = DesignerArgs.Arguments.Get(1)
		Dim fnt As B4XFont = StubLabel.Font
		For i = 2 To DesignerArgs.Arguments.Size - 1 Step 2
			Dim text As String = DesignerArgs.Arguments.Get(i)
			Dim tag As String = DesignerArgs.Arguments.Get(i + 1)
			Dim lbl As B4XView = CreateLabel
			lbl.Font = fnt
			If tag.StartsWith("FA_") Then
				lbl.Font = xui.CreateFontAwesome(fnt.Size * 2)
				tag = tag.SubString2(3, tag.Length)
			Else If tag.StartsWith("MI_") Then
				lbl.Font = xui.CreateMaterialIcons(fnt.Size * 2)
				tag = tag.SubString2(3, tag.Length)
			Else
				lbl.Font = fnt
			End If
			lbl.Text = text
			lbl.TextColor = B4XPages.MainPage.Theme.GetColor("Text.Norm")
			lbl.SetTextAlignment("CENTER", "CENTER")
			lbl.Tag = Array(DesignerArgs.LayoutModule, EventName, tag)
			pnl.AddView(lbl, 0, 0, 40dip, pnl.Height)
		Next
	Else
		For i = 0 To pnl.NumberOfViews - 1
			pnl.GetView(i).Height = pnl.Height
		Next
	End If
End Sub

Private Sub CreateLabel As B4XView
	Dim lbl As Label
	lbl.Initialize("lbl")
	Return lbl
End Sub

#if B4J
Private Sub lbl_MouseClicked (EventData As MouseEvent)
	RaiseToolbarEvent(Sender, Sender.As(B4XView).Tag)
	EventData.Consume
End Sub
#else
Private Sub lbl_Click
	RaiseToolbarEvent(Sender, Sender.As(B4XView).Tag)
End Sub
#End If

Private Sub RaiseToolbarEvent (lbl As B4XView, Data() As Object)
	CallSubDelayed2(Data(0), Data(1) & "_click", Data(2))
	If PressedColor <> 0 Then
		lbl.SetColorAnimated(100, xui.Color_Transparent, PressedColor)
		Sleep(100)
		lbl.SetColorAnimated(100, PressedColor, xui.Color_Transparent)
	End If
End Sub

'Same as B4X Chr keyword. Expects a single codepoint parameter.
Private Sub ToChr(DesignerArgs As DesignerArgs) As String
	Return "" & Chr(GetIntFromString(DesignerArgs.Arguments.Get(0)))
End Sub

Private Sub GetIntFromString (n As String) As Int
	If n.StartsWith("0x") Then
		Return Bit.ParseLong(n.SubString(2), 16)
	End If
	Return n
End Sub

'Spreads the controls evenly.
'Parameters: Panel, Maximum size of each control (0 for no maximum), Minimum gap between controls.
Private Sub SpreadControlsHorizontally (DesignerArgs As DesignerArgs)
	Dim Panel As B4XView = DesignerArgs.GetViewFromArgs(0)
	If Panel.IsInitialized = False Then Return
	Dim MaxSize As Int = DesignerArgs.Arguments.Get(1)
	If MaxSize = 0 Then MaxSize = 0x7fffffff
	Dim MinGap As Int = DesignerArgs.Arguments.Get(2)
	Dim AllWidth As Int = Panel.Width
	Dim w As Int = Min(AllWidth / Panel.NumberOfViews - MinGap, MaxSize)
	Dim gap As Int = (AllWidth - Panel.NumberOfViews * w) / Panel.NumberOfViews
	For i = 0 To Panel.NumberOfViews - 1
		Dim v As B4XView = Panel.GetView(i)
		v.SetLayoutAnimated(0, (i + 0.5) * gap + i * w, v.Top, w, v.Height)
	Next
End Sub